
import sys
if sys.version_info >= (3, 8):
    from typing import Protocol
else:
    from typing_extensions import Protocol

import fr.cnes.sirius.patrius.orbits
import fr.cnes.sirius.patrius.stela.forces
import java.util
import jpype
import typing



class TimeDerivativeData:
    def __init__(self, orbit: fr.cnes.sirius.patrius.orbits.Orbit, doubleArray: typing.Union[typing.List[float], jpype.JArray], doubleArray2: typing.Union[typing.List[typing.MutableSequence[float]], jpype.JArray], map: typing.Union[java.util.Map[fr.cnes.sirius.patrius.stela.forces.StelaForceModel, typing.Union[typing.List[float], jpype.JArray]], typing.Mapping[fr.cnes.sirius.patrius.stela.forces.StelaForceModel, typing.Union[typing.List[float], jpype.JArray]]], map2: typing.Union[java.util.Map[fr.cnes.sirius.patrius.stela.forces.StelaForceModel, typing.Union[typing.List[typing.MutableSequence[float]], jpype.JArray]], typing.Mapping[fr.cnes.sirius.patrius.stela.forces.StelaForceModel, typing.Union[typing.List[typing.MutableSequence[float]], jpype.JArray]]]): ...
    def getAvailableForceModels(self) -> java.util.Set[fr.cnes.sirius.patrius.stela.forces.StelaForceModel]: ...
    def getAvailableForceModelsSTM(self) -> java.util.Set[fr.cnes.sirius.patrius.stela.forces.StelaForceModel]: ...
    def getDerivatives(self, stelaForceModel: fr.cnes.sirius.patrius.stela.forces.StelaForceModel) -> typing.MutableSequence[float]: ...
    def getDerivativesSTM(self, stelaForceModel: fr.cnes.sirius.patrius.stela.forces.StelaForceModel) -> typing.MutableSequence[typing.MutableSequence[float]]: ...
    def getMeanMotion(self) -> typing.MutableSequence[float]: ...
    def getMeanMotionSTM(self) -> typing.MutableSequence[typing.MutableSequence[float]]: ...
    def getOrbit(self) -> fr.cnes.sirius.patrius.orbits.Orbit: ...
    def getTotalContribution(self) -> typing.MutableSequence[float]: ...
    def getTotalContributionSTM(self) -> typing.MutableSequence[typing.MutableSequence[float]]: ...


class __module_protocol__(Protocol):
    # A module protocol which reflects the result of ``jp.JPackage("fr.cnes.sirius.patrius.stela.propagation.data")``.

    TimeDerivativeData: typing.Type[TimeDerivativeData]
